// VideoStoreDlg.cpp : implementation file
//

#include "stdafx.h"
#include "khan.h"
#include "VideoStoreDlg.h"
#include "shlobj.h" // For SHFunctions


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVideoStoreDlg dialog


CVideoStoreDlg::CVideoStoreDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVideoStoreDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVideoStoreDlg)
	m_strText = _T("");
	m_strFolderPath = _T("");
	m_strText2 = _T("");
	//}}AFX_DATA_INIT
}


void CVideoStoreDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVideoStoreDlg)
	DDX_Control(pDX, IDCANCEL, m_ctrlButtonCancel);
	DDX_Control(pDX, IDOK, m_ctrlButtonOK);
	DDX_Control(pDX, IDC_EDIT_FOLDER_PATH, m_ctrlFolderPath);
	DDX_Text(pDX, IDC_STATIC_TEXT, m_strText);
	DDX_Text(pDX, IDC_EDIT_FOLDER_PATH, m_strFolderPath);
	DDX_Text(pDX, IDC_STATIC_TEXT2, m_strText2);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CVideoStoreDlg, CDialog)
	//{{AFX_MSG_MAP(CVideoStoreDlg)
	ON_BN_CLICKED(IDC_BUTTON_BROWSE, OnButtonBrowse)
	ON_WM_LBUTTONDOWN()
	ON_EN_CHANGE(IDC_EDIT_FOLDER_PATH, OnChangeEditFolderPath)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVideoStoreDlg message handlers

BOOL CVideoStoreDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// Set initial folder path.
	CDoc * pDoc = ((CApp*)AfxGetApp())->m_pDoc;
	if(pDoc)
	{
		m_strFolderPath = pDoc->m_videoStorePath;
	}

	// Set header string.
	m_strText = _T("Enter a Video Storage Folder path.\n")
				_T("For example:  C:\\Khan_video_folder\n");

	// Check if storage location is valid.
	// The user nay have moved or deleted it
	// between sessions.
	CString errMsg;
	int ret = ValidateFolder(m_strFolderPath, FALSE, errMsg);

	// Invalid forlder.
	// Can happen with removable dives.
	if(ret == 0)
	{
		m_strText2.Format(_T("Storage folder is invalid.\n%s"), errMsg);
	}
	// Folder has not been created.
	else if(ret == 2)
	{
		m_strText2.Format(_T("The Video Storage Folder:\n%s\n")
						  _T("will be created automatically."), m_strFolderPath);
	}
	// Set data string for valid existing folder.
	else
		SetDataString();

	// Display dialog data.
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

// User pressed Browse for folder button.
void CVideoStoreDlg::OnButtonBrowse() 
{
	BROWSEINFO bi;
	memset((LPVOID)&bi, 0, sizeof(bi));
	TCHAR szDisplayName[_MAX_PATH];
	szDisplayName[0] = '\0';
	bi.hwndOwner = GetSafeHwnd();
	bi.pidlRoot = NULL;
	bi.pszDisplayName = szDisplayName;
	bi.lpszTitle = _T("Pick a folder for video file storage:");
	bi.ulFlags = BIF_RETURNONLYFSDIRS;

	LPITEMIDLIST pIIL = ::SHBrowseForFolder(&bi);

	TCHAR szInitialDir[_MAX_PATH];

	// vc6.0
	//BOOL bRet = ::SHGetPathFromIDList(pIIL, (unsigned short*)&szInitialDir);

	// vs2005
	BOOL bRet = ::SHGetPathFromIDList(pIIL, (LPWSTR)&szInitialDir);
	
	if(bRet)
	{
		CString str = szInitialDir;
		if(!str.IsEmpty())
		{
			// Set member.
			m_strFolderPath = str;

			CString errMsg;
			int ret = ValidateFolder(m_strFolderPath, FALSE, errMsg);
			if(ret == 0)
			{
				m_strText2 = errMsg;
			}
			else if(ret == 2)
			{
				m_strText2.Format(_T("%s\nwill be created."), m_strFolderPath);
			}
			// Set data string.
			else
				SetDataString();

			UpdateData(FALSE);
		}

		LPMALLOC pMalloc;
		HRESULT hr = SHGetMalloc(&pMalloc);
		pMalloc->Free(pIIL);
		pMalloc->Release();
	}	
}

// test new
// Set the m_strText2 data string.
void CVideoStoreDlg::SetDataString()
{
	CDoc * pDoc = ((CApp*)AfxGetApp())->m_pDoc;
	if(!pDoc)
		return;

	// For old style file names.v0.8.4
	// Should eventually not need this.
	// See also CConvertVidFileNamesDlg.
	CTopicTree & tree = pDoc->GetTree();
	CString newFileName;
//	UINT	nOldFormat = 0;

	// Get total files and total size of files in directory.
	//
	// See : http://msdn.microsoft.com/en-us/library/aa364418%28VS.85%29.aspx
	// CAUTION: May not work on 64 bit platforms.
	WIN32_FIND_DATA	FindData;
	HANDLE	hFiles;
	UINT	nFileCount = 0;
	ULARGE_INTEGER	fileSz;
	_int64 nTotalFileSzKb = 0;
	CString fileName;

	CString dir = m_strFolderPath;
	dir += _T("\\*");

	if((hFiles = FindFirstFile(dir, &FindData)) != NULL)
	{
		while(FindNextFile(hFiles, &FindData))
		{
			// Watch for this or other directories.
			if(FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
				continue;

			// Count mp4 files only.
			fileName = FindData.cFileName;
			if(fileName.Find(_T(".mp4"), 0) == -1)
				continue;

			// A file.
			nFileCount++;

			// Total up sz.
			// File sz = (nFileSizeHigh * (MAXDWORD + 1)) + nFileSizeLow
			fileSz.LowPart = FindData.nFileSizeLow; 
			fileSz.HighPart = FindData.nFileSizeHigh; 
			nTotalFileSzKb += (_int64)fileSz.QuadPart / 1024;

			/* old - delete
			// Check if an old style Title file name. v 0.8.4
			if(tree.VideoFileUsedTitle(fileName))
			{
				nOldFormat++;
			}*/
		}
		FindClose(hFiles);
	}

	// Format sz.
	CString szStr;

	// GB
	if(nTotalFileSzKb > 1024 * 1024)
	{
		double d = (double)(nTotalFileSzKb) / (double)(1024 * 1024);
		szStr.Format(_T("%.2f GB"), d);
	}

	// MB
	else if(nTotalFileSzKb > 1024)
	{
		double d = (double)(nTotalFileSzKb) / double(1024);
		szStr.Format(_T("%.2f MB"), d);
	}

	// KB
	else if(nTotalFileSzKb)
		szStr.Format(_T("%d KB"), (int)nTotalFileSzKb);

	// Empty / non existant / invalid.
	else
		szStr = _T("0 MB");

	m_strText2.Format(	_T("  Folder: %s\n")
						_T("  Total videos: %d\n")
						_T("  Total video size on disk: %s"),
						m_strFolderPath, nFileCount, szStr);

	/* old - delete
	// If old video file names.
	if(nOldFormat)
	{
		CString s;
		s.Format(_T("Video files must now be named using their Khan Server file name.\n")
				 _T("This requires %d of your existing video files to be renamed.\n")
				 _T("Renaming these files is easily done with the Rename Video\n")
				 _T("Files tool located under the Tools menu item.\n")
				 _T("Please see the Help file for more information."), nOldFormat);

	/ *	s.Format(_T("Video files are now named using their Khan Server name.\n")
				 _T("This requires %d of your existing video files to be remamed.\n")
				 _T("You can easily do this with the Rename Video Files tool\n")
				 _T("located under the Tools menu item.\n")
				 _T("For more information please see the Help file."), nOldFormat);* /

		MessageBox(s, _T("Khan Desktop - New Video File Name Format"), MB_OK | MB_ICONINFORMATION);

	}*/
}

/*rework for old vid names.
// Set the m_strText2 data string.
void CVideoStoreDlg::SetDataString()
{
	// Get total files and total size of files in directory.
	//
	// See : http://msdn.microsoft.com/en-us/library/aa364418%28VS.85%29.aspx
	// CAUTION: May not work on 64 bit platforms.
	WIN32_FIND_DATA	FindData;
	HANDLE	hFiles;
	UINT	nFileCount = 0;
	ULARGE_INTEGER	fileSz;
	_int64 nTotalFileSzKb = 0;
	CString dir = m_strFolderPath;
	CString fileName;
	dir += _T("\\*");

	if((hFiles = FindFirstFile(dir, &FindData)) != NULL)
	{
		while(FindNextFile(hFiles, &FindData))
		{
			// Watch for this or other directories.
			if(FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
				continue;

			// Count mp4 files only.
			fileName = FindData.cFileName;
			if(fileName.Find(_T(".mp4"), 0) == -1)
				continue;

			// A file.
			nFileCount++;

			// Total up sz.
			// File sz = (nFileSizeHigh * (MAXDWORD + 1)) + nFileSizeLow
			fileSz.LowPart = FindData.nFileSizeLow; 
			fileSz.HighPart = FindData.nFileSizeHigh; 
			nTotalFileSzKb += (_int64)fileSz.QuadPart / 1024;
		}
		FindClose(hFiles);
	}

	// Format sz.
	CString szStr;

	// GB
	if(nTotalFileSzKb > 1024 * 1024)
	{
		double d = (double)(nTotalFileSzKb) / (double)(1024 * 1024);
		szStr.Format(_T("%.2f GB"), d);
	}

	// MB
	else if(nTotalFileSzKb > 1024)
	{
		double d = (double)(nTotalFileSzKb) / double(1024);
		szStr.Format(_T("%.2f MB"), d);
	}

	// KB
	else if(nTotalFileSzKb)
		szStr.Format(_T("%d KB"), (int)nTotalFileSzKb);

	// Empty / non existant / invalid.
	else
		szStr = _T("0 MB");

	m_strText2.Format(	_T("  Folder: %s\n")
						_T("  Total videos: %d\n")
						_T("  Total size on disk: %s"),
						m_strFolderPath, nFileCount, szStr);
}

*/

// Validate a folder path.
// 
// Return:
//	0 if invalid path.
//	1 for valid folder exists or has been created.
//	2 folder can be successfully created.
int CVideoStoreDlg::ValidateFolder(CString path, BOOL createFolder, CString & errMsg)
{
	// Validate the folder.
	int len = path.GetLength();

	// If empty or only a directory, e.g. "c:\".
	if(len <= 3)
	{
		// Directory only.
		if(len == 3 && path[2] == _T('\\') )
			errMsg = _T("Please include a Folder name.");

		// Not valid or empty.
		else
			errMsg = _T("Please enter a valid Video Storage Folder path.");

		return 0;
	}

	// Check drive type. 
	CString drive;
	int i = path.Find(_T('\\'), 0);
	if(i == 2)
	{
		CString drive = path.Left(i + 1);
		UINT type = GetDriveType(drive);
		if(type == DRIVE_CDROM			||
		   type == DRIVE_UNKNOWN		||
		   type == DRIVE_NO_ROOT_DIR)
		{
			if(type == DRIVE_CDROM)
				errMsg = _T("Cannot access CD-ROM directly.");
			else
				errMsg = _T("Drive is not accessable.");
			return 0;
		}
	}
	// Bad path
	else
	{
		errMsg = _T("Please enter a valid Video Storage Folder path.");
		return 0;
	}

	// Check if directory exists or can be created.
	// IMPORTANT: Spaces at end of path are not checked by api.
	//			  OnOk() removes them.
	if(!CreateDirectory(path, NULL))
	{
		DWORD err = GetLastError();

		// If exists.
		if(err == ERROR_ALREADY_EXISTS) // code 183
		{
			// Ok.
			return 1;
		}
		// Cannot be created.
		else
		{
			// Format last error.
			LPVOID lpMsgBuf;
			FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
						  FORMAT_MESSAGE_FROM_SYSTEM	 |
						  FORMAT_MESSAGE_IGNORE_INSERTS,
						  NULL,
						  err,
						  MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
						  (LPTSTR) &lpMsgBuf,
						  0,
						  NULL);

			// Format err msg.
			errMsg.Format(_T("%s"), lpMsgBuf);
			errMsg.TrimRight();

			// Clean up.
			LocalFree(lpMsgBuf);

			return 0;		
		}
	}

	// New directory was created. Delete per param.
	else
	{
		// Folder creation temporary.
		if(!createFolder)
		{
			RemoveDirectory(path);
			return 2;
		}
		// Folder created fine.
		return 1;
	}
	return 0;
}

// Ok button pressed.
void CVideoStoreDlg::OnOK() 
{
	// Get the entry.
	UpdateData();

	int len = m_strFolderPath.GetLength();

	// Delete all Spaces, Back Slashes and Periods at end of path.
	// Looping backwards.
	// Per ms doc: "Naming Files, Paths, and Namespaces (Windows)"
	for(int i = len - 1; i > 2; i --)
	{
		if(m_strFolderPath[i] == _T(' '))			// spaces
			m_strFolderPath.Delete(i, 1);
		else if(m_strFolderPath[i] == _T('.'))		// periods
			m_strFolderPath.Delete(i, 1);
		else if(m_strFolderPath[i] == _T('\\'))		// back slashes
			m_strFolderPath.Delete(i, 1);
		else
			break;
	}

	// Update for any changes - framework calls UpdateData()
	// to retrieve text.
	if(m_strFolderPath.GetLength() != len)
		m_ctrlFolderPath.SetWindowText(m_strFolderPath);

	CString errMsg;

	// Ensure a valid storage location.
	//
	// Note - folder is created if needed.
	if(!ValidateFolder(m_strFolderPath, TRUE, errMsg))
	{
		m_strText2.Format(_T("Cannot create storage folder.\n%s"), errMsg);

		// Display dialog data.
		UpdateData(FALSE);


		// User to fix or cancel.
		return;
	}
	// Ok	
	CDialog::OnOK();
}

// User has clicked on a non control area of the dialog.
// Check if storage location is valid and show the 
// folder data.
void CVideoStoreDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// Get current text.
	UpdateData();

	CString errMsg;
	int ret = ValidateFolder(m_strFolderPath, FALSE, errMsg);
	if(ret == 0)
	{
		m_strText2.Format(_T("Cannot create storage folder.\n%s"), errMsg);

	}
	else if(ret == 2)
	{
		m_strText2.Format(_T("The Video Storage Folder:\n%s\n")
						  _T("will be created automatically."), m_strFolderPath);
	}
	// Set data string.
	else
		SetDataString();

	// Update dialog.
	// Load strings.
	UpdateData(FALSE);

	// Set focus to cancel button.
	m_ctrlButtonCancel.SetFocus();


	// Base class.
	CDialog::OnLButtonDown(nFlags, point);
}

// User entering chars in edit ctrl.
void CVideoStoreDlg::OnChangeEditFolderPath() 
{
	// Not for a RICHEDIT control.

	//
	// Note: 
	// Calls to win32 folder api in ValidateFolder() will
	// make additional checks for bad chars before folder 
	// creation.
	// This code only checks the last char entered to
	// provide a more friendly interface.
	//

	// Get current text.
	CString str;
	BOOL remove = FALSE;
	m_ctrlFolderPath.GetWindowText(str);

	// Get length.
	int len = str.GetLength();

	// If beyond the drive.
	if(len > 3 && str[2] == _T('\\'))
	{
		int c = str[len - 1];
		
		// From space back.
		if(c < 32)			
			remove = TRUE;

		// Space at end of path. Will need to catch in OnOK().
		else if(c == 32)
		{
			// Get current text.
			UpdateData();

			// Info user.
			m_strText2 = _T("Note spaces will be removed from\n")
						 _T("the end of the folder path.");
			UpdateData(FALSE);

			// Position caret.
			m_ctrlFolderPath.SetSel(len, len);
			return;
		}

		// Periods at end of path. Will need to catch in OnOK().
		else if(c == 46)
		{
			UpdateData();
			m_strText2 = _T("Note periods will be removed from\n")
						 _T("the end of the folder path.");
			UpdateData(FALSE);
			m_ctrlFolderPath.SetSel(len, len);
			return;
		}

		// Back Slash at end of path. Will need to catch in OnOK().
		else if(c == 92)
		{
			UpdateData();
			m_strText2 = _T("Note back slashes will be removed from\n")
						 _T("the end of the folder path.");
			UpdateData(FALSE);
			m_ctrlFolderPath.SetSel(len, len);
			return;
		}
		// Misc.
		else
		{
			switch(c)
			{
			case 22:	// "
		//	case 32:	// space - allowed in between but not at end
			case 42:	// *
		//	case 46:	// . period
			case 47:	// /
			case 58:	// :
			case 60:	// <
			case 62:	// >
			case 63:	// ?
		//	case 92:	// back slash
			case 124:	// |
				remove = TRUE;
				break;
			default:
				break;
			}
		}

		// If a bad char, delete and info user..
		if(remove)
		{			
			CString removed = str[len - 1];

			// Delete last char.
			str.Delete(len - 1, 1);

			// Set new text.
			m_strFolderPath = str;
			m_ctrlFolderPath.SetWindowText(str);

			// Info.
			m_strText2.Format(_T("The input character: %s\n")
							  _T("cannot be used."), removed);
			UpdateData(FALSE);

			// Position caret before deleted char - end of new path..
			m_ctrlFolderPath.SetSel(len - 1, len - 1);
			return;
		}

		// Else validate for each char to give user feedback.
		// Note OnLeftButton() down also does this.
		else
		{
			// Get current text.
			UpdateData();

			CString errMsg;
			int ret = ValidateFolder(m_strFolderPath, FALSE, errMsg);
			if(ret == 0)
			{
				m_strText2.Format(_T("Cannot create storage folder.\n%s"), errMsg);
			}
			else if(ret == 2)
			{
				m_strText2.Format(_T("The Video Storage Folder:\n  %s\n")
								  _T("will be created automatically."), m_strFolderPath);
			}
			// Set data string.
			else
				SetDataString();

			// Update dialog.
			// Load strings.
			UpdateData(FALSE);
			return;
		}
	}
	// String is less than 3 chars. 
	// ValidateFolder() will error check.
	else
	{
		// Get current text.
		UpdateData();

		CString errMsg;

		// Should always return 0 for 3 or less chars.
		int ret = ValidateFolder(m_strFolderPath, FALSE, errMsg);

		if(ret == 0)
		{
			m_strText2.Format(_T("Cannot create storage folder.\n%s"), errMsg);
		}
		else if(ret == 2)
		{
			m_strText2.Format(_T("The Video Storage Folder:\n  %s\n")
							  _T("will be created automatically."), m_strFolderPath);
		}
		// Set data string.
		else
			SetDataString();

		// Update dialog.
		// Load strings.
		UpdateData(FALSE);
	}
}

/* from: http://forums.codeguru.com/showthread.php?301326-CreateDirectory-and-SECURITY_ATTRIBUTES
DWORD CreateDirWithSecurity(LPCTSTR lpPath)
{
    SECURITY_ATTRIBUTES  sa;
    SECURITY_DESCRIPTOR  sd;
    PACL                 pAcl = NULL;
    DWORD                cbAcl = 0,dwNeeded = 0,dwError = 0;
    HANDLE               hToken;
    PTOKEN_USER          ptu = NULL;
    
    if(!OpenProcessToken( GetCurrentProcess(), TOKEN_QUERY, &hToken))
        return GetLastError();
    

    GetTokenInformation( hToken, TokenUser, NULL, 0, &dwNeeded);
    if(GetLastError() != ERROR_INSUFFICIENT_BUFFER) 
    {
        dwError = GetLastError();
        goto cleanup;
    }

    ptu = (TOKEN_USER*)malloc(dwNeeded);
    if (!GetTokenInformation(hToken, TokenUser, ptu, dwNeeded, &dwNeeded))
    {
        dwError = GetLastError();
        goto cleanup;
    }
    
    cbAcl = sizeof(ACL) + ((sizeof(ACCESS_ALLOWED_ACE) - sizeof(DWORD)) + GetLengthSid(ptu->User.Sid));
    pAcl = (ACL*) malloc (cbAcl);

    if(!InitializeAcl(pAcl, cbAcl, ACL_REVISION))
    {
        dwError = GetLastError();
        goto cleanup;
    }

    if(!AddAccessAllowedAce(pAcl,ACL_REVISION,GENERIC_ALL|STANDARD_RIGHTS_ALL|SPECIFIC_RIGHTS_ALL,ptu->User.Sid))
    {
        dwError = GetLastError();
        goto cleanup;
    }

    InitializeSecurityDescriptor(&sd,SECURITY_DESCRIPTOR_REVISION);

    SetSecurityDescriptorDacl(&sd,TRUE,pAcl,FALSE);
    SetSecurityDescriptorOwner(&sd,ptu->User.Sid,FALSE);
    SetSecurityDescriptorGroup(&sd,NULL,FALSE); 
    SetSecurityDescriptorSacl(&sd, FALSE,NULL,FALSE);

    sa.nLength = sizeof(SECURITY_ATTRIBUTES);
    sa.lpSecurityDescriptor = &sd;
    sa.bInheritHandle = TRUE;

    CreateDirectory(lpPath, &sa);

    dwError = GetLastError();

cleanup:
    if(ptu) free(ptu);
    if(pAcl) free(pAcl);

    CloseHandle(hToken);
    return dwError;
}

/////////////////////////
another from : http://www.tenouk.com/ModuleJ.html

// CreateMyDACL.
//    Create a security descriptor that contains the DACL you want.
//    This function uses SDDL to make Deny and Allow ACEs.
//
// Parameter:
//    SECURITY_ATTRIBUTES * pSA
//    Pointer to a SECURITY_ATTRIBUTES structure. It is the caller's
//    responsibility to properly initialize the structure and to free 
//	  the structure's lpSecurityDescriptor member when the caller has
//    finished using it. To free the structure's lpSecurityDescriptor 
//	  member, call the LocalFree function.
//
// Return value:
//    FALSE if the address to the structure is NULL. Otherwise, this 
//    function returns the value from the
//    ConvertStringSecurityDescriptorToSecurityDescriptor function.

BOOL CreateMyDACL(SECURITY_ATTRIBUTES * pSA)
{
 // Define the SDDL for the DACL. This example sets the following access:

 // Deny all for built-in Administrators group Allow read/write/execute to 
 // Authenticated users

 // Allow all to anonymous logon Allow all to built-in guests. This is not 
 // a proper setting, how come you deny the Administrator lol!!!

 // But this example just for fun...

 TCHAR * szSD = TEXT("D:")    // Discretionary ACL
 TEXT("(D;OICI;GA;;;BA)")     // Deny all for built-in Administrators group :o)
 TEXT("(D;OICI;GRGWGX;;;AU)") // Allow read/write/execute to Authenticated users
 TEXT("(A;OICI;GA;;;AN)")     // Allow all to anonymous logon
 TEXT("(A;OICI;GA;;;BG)");    // Allow all to built-in guests 

 if(pSA == NULL)
      return FALSE; 

 PULONG nSize = 0;
 // Do some verification
 printf("The ACE strings: %s \n", szSD);
 printf("The converted string is at: %p \n", &(pSA->lpSecurityDescriptor)); 

 // Convert the string to the security descriptor binary and return
 return ConvertStringSecurityDescriptorToSecurityDescriptor(
        szSD,                         // The ACE strings
        SDDL_REVISION_1,              // Standard revision level
        &(pSA->lpSecurityDescriptor), // Pointer to the converted security descriptor
        nSize);                // The size in byte the converted security descriptor
}

*/
